<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * JMForm Component Controller
 * @package JMForm
 */
class JmformControllerCreacamp extends JController
{

	/**
	 * Constructor
	 * @return void
	 */
	function __construct()
	{
    	parent::__construct();
    	// Els botons nou i editar son la mateixa tasca
    	$this->registerTask( 'add', 'edit' );
	}

	/**
	 * Accio del boto corretgir/nou
	 * @return void
	 */
	function edit()
	{
	    JRequest::setVar( 'view', 'creacamp' );
	    JRequest::setVar( 'layout', 'default'  );
	    JRequest::setVar( 'hidemainmenu', 1);
	
	    parent::display();
	}

	/**
	 * Accio del boto desa
	 * Guarda un camp i envia a la pagina inicial
	 * @return void
	 */
	function save()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel( 'creacamp' );
	
		if ($model->store()) {
        	$msg = JText::_( 'camp guardat' );
  			$type = 'message';
	    } else {
	        $msg = JText::_( 'Error guardant camp' );
	        $type = 'error';
	    }
			
		$this->setRedirect( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm(), $msg, $type );
	}

	/**
	 * Accio del boto esborrar
	 * Elimina el camp i envia a la pagina inicial
	 * @return void
	 */
	function remove()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel( 'creacamp' );
		if(!$model->delete()) {
			$msg = JText::_( 'error eliminant camp' );
			$type = 'error';
		} else {
			$msg = JText::_( 'camp eliminat' );
			$type = 'message';
		}
		$this->setRedirect( JRoute::_( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm(), false ), $msg, $type );
	}
	
	/**
	 * Accio del boto cancelar
	 * @return void
	 */
	function cancel()
	{
			$model = $this->getModel( 'creacamp' );
	    $msg = JText::_( 'operacio cancelada' );
	    $this->setRedirect( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm(), $msg, 'notice' );
	}
	
	/**
	 * Accio del boto publicar
	 * @return void
	 */
	function publish() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel( 'creacamp' );
		if($model->publish(1)) {
			$msg = JText::_( 'CAMP PUBLICAT' );
			$type = 'message';
		}
		else
		{
			$msg = JText::_( 'Error estat camp' )." - " .$model->getError();
			$type = 'error';
		}
		$this->setRedirect( JRoute::_( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm(), false ), $msg, $type );
	}
 	
 	/**
	 * Accio del boto despublicar
	 * @return void
	 */
 	function unpublish() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel( 'creacamp' );
		if($model->publish(0)) {
			$msg = JText::_( 'CAMP DESPUBLICAT' );
			$type = 'message';
		}
		else
		{
			$msg = JText::_( 'Error estat camp' )." - " .$model->getError();
			$type = 'error';
		}
		$this->setRedirect( JRoute::_( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm(), false ), $msg, $type );
	}

 	/**
	 * Accio al clicar al disquet de guardar ordre
	 * @return void
	 */	
	function saveOrder()
	{
	global $mainframe;
	$model = $this->getModel( 'creacamp' );
	
	$cid  = JRequest::getVar('cid', array());
	JArrayHelper::toInteger($cid);
	
	$database   =& JFactory::getDBO();
	$total		= count( $cid );
	$order 		= JRequest::getVar('order',array(), 'POST');

	// actualitza valors de ordenacio
	for( $i=0; $i < $total; $i++ ) { // ho repetim per tots els camps del formulari
		$database->setQuery("SELECT ordre FROM #__jmform_camps WHERE id = '".$cid[$i]."'");
		$ordre = (int)$database->loadResult();

		if ($ordre != $order[$i]) { // si es canvia el ordre del camp es guarda
			$row->ordering = $order[$i];
			$query = "UPDATE #__jmform_camps"
				. " SET ordre = ".$order[$i]
				. " WHERE id = ".$cid[$i];
			$database->setQuery($query);
			$database->query();
		}
	}

	$mainframe->redirect( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm()  );
	}

 	/**
	 * Accio al clicar la fletxa de pujar de ordre un camp
	 * @return void
	 */	
function orderupfield()
{
	global $mainframe;
	$model = $this->getModel( 'creacamp' );
	
	$cid  = JRequest::getVar('cid', array());
	$id = $cid[0];
	$database =& JFactory::getDBO();
	// Busquem l'ordre del camp 
	$query = "SELECT ordre FROM #__jmform_camps WHERE id = ".$id;
	$database->setQuery($query);
	$ordre = $database->loadResult();
	// Actualitzem al nou ordre
	$nouordre = $ordre -1;
	$query = "UPDATE #__jmform_camps"
	. " SET ordre = ".$nouordre
	. " WHERE id = ".$id;
	$database->setQuery($query);
	$database->query();

	$mainframe->redirect( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm());
}	
	
 	/**
	 * Accio al clicar la fletxa de baixar de ordre un camp
	 * @return void
	 */	
function orderdownfield()
{
	global $mainframe;
	$model = $this->getModel( 'creacamp' );

	$cid  = JRequest::getVar('cid', array());
	$id = $cid[0];
	$database =& JFactory::getDBO();
	// Busquem l'ordre del camp 
	$query = "SELECT ordre FROM #__jmform_camps WHERE id = ".$id;
	$database->setQuery($query);
	$ordre = $database->loadResult();
	$nouordre = $ordre +1;
	// Actualitzem al nou ordre
	$query = "UPDATE #__jmform_camps"
	. " SET ordre = ".$nouordre
	. " WHERE id = ".$id;
	$database->setQuery($query);
	$database->query();

	$mainframe->redirect( 'index.php?option=com_jmform&view=camps&cid[]='.$model->getIdForm());
}	
	
}
?>
