<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );


/**
 * JMForm Component Controller
 * @package JMForm
 */
class JmformControllerCreaform extends JController
{

	/**
	 * Constructor
	 * @return void
	 */
	function __construct()
	{
    	parent::__construct();
    	// Els botons nou i editar son la mateixa tasca
    	$this->registerTask( 'add', 'edit' );
	}

	/**
	 * Accio del boto corretgir/nou
	 * @return void
	 */
	function edit()
	{
	    JRequest::setVar( 'view', 'creaform' );
	    JRequest::setVar( 'layout', 'default'  );
	    JRequest::setVar( 'hidemainmenu', 1);
	
	    parent::display();
	}

	/**
	 * Accio del boto desa
	 * Guarda un informe i envia a la pagina inicial
	 * @return void
	 */
	function save()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel( 'creaform' );
	
		if ($model->store()) {
        	$msg = JText::_( 'informe guardat' );
  			$type = 'message';
	    } else {
	        $msg = JText::_( 'Error guardant informe' );
	        $type = 'error';
	    }
			
		$this->setRedirect( 'index.php?option=com_jmform', $msg, $type );
	}

	/**
	 * Accio del boto esborrar
	 * Elimina informe i envia a la pagina inicial
	 * @return void
	 */
	function remove()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel( 'creaform' );
		if(!$model->delete()) {
			$msg = JText::_( 'error eliminant informe' );
			$type = 'error';
		} else {
			$msg = JText::_( 'informe eliminat' );
			$type = 'message';
		}
		$this->setRedirect( JRoute::_( 'index.php?option=com_jmform', false ), $msg, $type );
	}
	
	/**
	 * Accio del boto cancelar
	 * @return void
	 */
	function cancel()
	{
	    $msg = JText::_( 'operacio cancelada' );
	    $this->setRedirect( 'index.php?option=com_jmform', $msg, 'notice' );
	}
	
	/**
	 * Accio del boto publicar
	 * @return void
	 */
	function publish() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel( 'creaform' );
		if($model->publish(1)) {
			$msg = JText::_( 'INFORME PUBLICAT' );
			$type = 'message';
		}
		else
		{
			$msg = JText::_( 'Error estat informe' )." - " .$model->getError();
			$type = 'error';
		}
		$this->setRedirect( JRoute::_( 'index.php?option=com_jmform', false ), $msg, $type );
	}
 	
 	/**
	 * Accio del boto despublicar
	 * @return void
	 */
 	function unpublish() {
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$model = $this->getModel( 'creaform' );
		if($model->publish(0)) {
			$msg = JText::_( 'INFORME DESPUBLICAT' );
			$type = 'message';
		}
		else
		{
			$msg = JText::_( 'Error estat informe' )." - " .$model->getError();
			$type = 'error';
		}
		$this->setRedirect( JRoute::_( 'index.php?option=com_jmform', false ), $msg, $type );
	}
	
}
?>
