<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * JMForm Model
 * @package JMForm
 */
class JmformModelCamps extends JModel
{
	/**
	 * JMForm entry array
	 * @var array
	 */

	var $_data = null;
	var $_id_formulari = null;
	
	/**
	 * Constructor, ens dona l'ID que es passa a l'URL com a variable
	 * @access public
	 * @return void
	 */
	function __construct()
	{
	    parent::__construct();
	    	
	    $array = JRequest::getVar('cid',  0, '', 'array');
	    $this->setId((int)$array[0]);
	}
	
	/**
 	 * Metode que afegeix un ID de formulari
 	 * @access public
 	 * @param Identificador (int) del formulari
 	 * @return void
 	 */
	function setId($id_formulari)
	{
    	// Afegeix l'ID i elimina les dades
    	$this->_id_formulari = $id_formulari;
    	// $this->_data = null;
	}
	
	/**
 	 * Metode que obt l'ID de formulari
 	 * @access public
 	 * @return integer Identificador del formulari
 	 */
	function getIdForm()
	{
  	return $this->_id_formulari;
	}
	
	/**
 	 * Metode que obt el nom del formulari
 	 * @access public
 	 * @return Nom del formulari
 	 */
	function getNomForm()
	{
   $db =& JFactory::getDBO();
 
   $query = "SELECT nom FROM #__jmform_formularis"
   . " WHERE id = ".$this->_id_formulari;
   $db->setQuery( $query );
   $nomform = $db->loadResult();
 
   return $nomform;
	}
	
	/**
	 * Fa una consulta a la base de dades de camps
	 * @return Un string que utilitzarem per treure la informacio de la taula
	 */
	function _buildQuery()
	{
		$query = "SELECT c.*, f.nom AS nomform FROM #__jmform_camps AS c"
		. " LEFT JOIN `#__jmform_formularis` AS f on f.id = c.id_formulari"
		. " WHERE id_formulari = ".$this->_id_formulari
		. " ORDER BY c.ordre";
	
		return $query;
	}

	/**
	 * Retorna les entrades de camps
	 * @return Array d'objectes que conte la informacio de la base de dades
	 */
	function getData()
	{
		if (empty( $this->_data ))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query );
		}
		return $this->_data;
	}
	
	/**
	 * Metode per obtenir el nombre total de camps
	 * @access public
	 * @return integer
	 */
	function getTotal()
	{
		// Carreguem el contingut si no n'hi ha
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

}
