<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * JMForm Model
 * @package JMForm
 */
class JmformModelCreacamp extends JModel
{
var $_data = null;
var $_id = null;			
var $_idForm = null;	

	/**
	 * Constructor, ens dona l'ID que es passa a l'URL com a variable
	 * @access public
	 * @return void
	 */
	function __construct()
	{
	    parent::__construct();
	
	    $array = JRequest::getVar('cid',  0, '', 'array');
	    $this->setId((int)$array[0]);
	    $array = JRequest::getVar('idForm',  0, '', 'array');
	    $this->setIdForm((int)$array[0]);
	}
	
	/**
 	 * Metode que afegeix un ID de camp
 	 * @access public
 	 * @param Identificador (int) del camp
 	 * @return void
 	 */
	function setId($id)
	{
    	// Afegeix l'ID i elimina les dades
    	$this->_id = $id;
    	$this->_data = null;
	}
	
	/**
 	 * Metode que afegeix un ID de formulari
 	 * @access public
 	 * @param Identificador (int) del formulari
 	 * @return void
 	 */
	function setIdForm($id_formulari)
	{
    	// Afegeix l'ID i elimina les dades
    	$this->_idForm = $id_formulari;
	}

	/**
 	 * Metode que obt l'ID de formulari
 	 * @access public
 	 * @return integer Identificador del formulari
 	 */
	function getIdForm()
	{
  	return $this->_idForm;
	}
	
	/**
 	 * Metode que recupera un camp
 	 * @return Objecte amb la informacio del camp
 	 */
	function &getData()
	{
    	// Carrega la informacio
    	if(empty( $this->_data )) {
       	 $query = ' SELECT * FROM #__jmform_camps'.
       	         '  WHERE id = '.$this->_id;
       	 $this->_db->setQuery( $query );
       	 $this->_data = $this->_db->loadObject();
    	}
    	if (!$this->_data) {
    	    $this->_data = $this->getTable();
    	    $this->_data->id = 0;
    	}    	    
    	return $this->_data;
	}
	
	/**
	 * Metode que guarda un camp
   * @access public
   * @return Cert si finalitza correctament
 	 */
	function store()
	{    	
    	$row =& $this->getTable();
    	$data = JRequest::get( 'post' );
    	$db   =& JFactory::getDBO();

			$data['id_formulari'] = $this->_idForm;
			// Si es un camp nou li donem el nou numero de ordre
			if ($data['id'] == 0) {
				$db->setQuery("SELECT ordre FROM #__jmform_camps WHERE id_formulari = '".$this->_idForm."' ORDER BY ordre DESC");
				$data['ordre'] = (int)$db->loadResult() + 1;
			}

    	// Comprova la correspondencia dels camps del formulari amb la taula
    	if (!$row->bind($data)) {
       	 	$this->setError($this->_db->getErrorMsg());
        	return false;
    	}
		
		  // Comprovem que les dades siguin correctes
	    if (!$row->check()) {
	        $this->setError($this->_db->getErrorMsg());
	        return false;
	    }
		
   		// Guardem el formulari a la base de dades
    	if (!$row->store()) {
        	$this->setError($this->_db->getErrorMsg());
        	return false;
    	}

    	return true;
	}
		
	/**
	 * Metode que elimina els camps marcats
   * @access public
   * @return Cert si finalitza correctament
 	 */
	function delete()
	{
	    $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	    $row =& $this->getTable();
	
	    foreach($cids as $cid) {
	        if (!$row->delete( $cid )) {
	            $this->setError( $row->_db->getErrorMsg() );
	            return false;
	        }
	    }
	
	    return true;
	}

	/**
	* Metode que publica o retira la publicacio d'un camp
	* @return	boolean	Cert si es fa correctament
	*/
	function publish($state) {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	    $row =& $this->getTable();
	
	        if (!$row->publish( $cids, $state )) {
	            $this->setError( $row->getError() );
	            return false;
	        }
	
	    return true;
	}
	
}
