<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * JMForm Model
 * @package JMForm
 */
class JmformModelCreaform extends JModel
{
var $_data = null;
var $_id = null;			


	/**
	 * Constructor, ens dona l'ID que es passa a l'URL com a variable
	 * @access public
	 * @return void
	 */
	function __construct()
	{
	    parent::__construct();
	
	    $array = JRequest::getVar('cid',  0, '', 'array');
	    $this->setId((int)$array[0]);
	}
	
	/**
 	 * Metode que afegeix un ID de formulari
 	 * @access public
 	 * @param Identificador (int) del formulari
 	 * @return void
 	 */
	function setId($id)
	{
    	// Afegeix l'ID i elimina les dades
    	$this->_id = $id;
    	$this->_data = null;
	}
	
	/**
 	 * Metode que recupera un formulari
 	 * @return Objecte amb la informacio del formulari
 	 */
	function &getData()
	{
    	// Carrega la informacio
    	if(empty( $this->_data )) {
       	 $query = ' SELECT * FROM #__jmform_formularis'.
       	         '  WHERE id = '.$this->_id;
       	 $this->_db->setQuery( $query );
       	 $this->_data = $this->_db->loadObject();
    	}
    	if (!$this->_data) {
    	    $this->_data = $this->getTable();
    	    $this->_data->id = 0;
    	}    	    
    	return $this->_data;
	}
	
	/**
	 * Metode que guarda un formulari
   * @access public
   * @return Cert si finalitza correctament
 	 */
	function store()
	{    	
		  global $mainframe;
    	jimport('joomla.utilities.date');
    	jimport('joomla.mail.helper');
		
    	$row =& $this->getTable();
    	$data = JRequest::get( 'post' );
    	$date =& JFactory::getDate();
    	$user =& JFactory::getUser();
    	
    	// Comprovem que sigui una adrea de correu valida
    	if (JMailHelper::isEmailAddress($data['email_noves_entrades']) ) {
      	$this->setError( JText::_( 'EMAIL INCORRECTE' ) );
        // return false;
      }

			// Afegim valors per defecte: data de creacio del formulari i ID de l'usuari creador
			if(!$data['id'])
			{
				$data['data_creacio'] = $date->toMysql();
				if($user->get('id')) {
					$data['id_usuari_creador'] = $user->get('id');
				}
			}

    	// Comprova la correspondencia dels camps del formulari amb la taula
    	if (!$row->bind($data)) {
       	 	$this->setError($this->_db->getErrorMsg());
        	return false;
    	}
		
		  // Comprovem que les dades siguin correctes
	    if (!$row->check()) {
	        $this->setError($this->_db->getErrorMsg());
	        return false;
	    }
		
   		// Guardem el formulari a la base de dades
    	if (!$row->store()) {
        	$this->setError($this->_db->getErrorMsg());
        	return false;
    	}

    	return true;
	}
		
	/**
	 * Metode que elimina els formularis marcats
	 * incloent els camps i els resultats
   * @access public
   * @return Cert si finalitza correctament
 	 */
	function delete()
	{
			$database =& JFactory::getDBO();
	    $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	    $row =& $this->getTable();
	
	    foreach($cids as $cid) {
	        if (!$row->delete( $cid )) {
	            $this->setError( $row->_db->getErrorMsg() );
	            return false;
	        }
	        // Eliminem els camps del formulari
	        $database->setQuery("DELETE FROM #__jmform_camps WHERE id_formulari = ".$cid);
					$database->query();
					// Eliminem els resultats del formulari
					$database->setQuery("DELETE FROM #__jmform_resultats WHERE id_formulari = ".$cid);
					$database->query();
	    }
	
	    return true;
	}

	/**
	* Metode que publica o retira la publicacio d'un informe
	* @return	boolean	Cert si es fa correctament
	*/
	function publish($state) {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	    $row =& $this->getTable();
	
	        if (!$row->publish( $cids, $state )) {
	            $this->setError( $row->getError() );
	            return false;
	        }
	
	    return true;
	}
	
}
