<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * JMForm Model
 * @package JMForm
 */
class JmformModelResultatsgrafic extends JModel
{
	/**
	 * JMForm entry array
	 * @var array
	 */

	var $_data = null;
	var $_idForm = null;
	
	/**
	 * Constructor, ens dona l'ID que es passa a l'URL com a variable
	 * @access public
	 * @return void
	 */
	function __construct()
	{
	    parent::__construct();
	
	    $array = JRequest::getVar('fid',  0, '', 'array');
	    $this->setIdForm((int)$array[0]);
	}
	
	/**
 	 * Metode que afegeix un ID de formulari
 	 * @access public
 	 * @param Identificador (int) del formulari
 	 * @return void
 	 */
	function setIdForm($id)
	{
    	// Afegeix l'ID
    	$this->_idForm = $id;
	}
	
	/**
	 * Fa una consulta a la base de dades de resultats
	 * @return Un string que utilitzarem per treure la informacio de la taula
	 */
	function _buildQuery()
	{
		$query = "SELECT r.*, u.name as autor, f.nom as nomform FROM #__jmform_resultats as r"
		. " LEFT JOIN `#__users` AS u on r.id_usuari = u.id"
		. " LEFT JOIN `#__jmform_formularis` AS f on r.id_formulari = f.id"
		. " WHERE id_formulari = ".$this->_idForm
		. " ORDER BY data DESC";
	
		return $query;
	}
	
	/**
	 * Retorna les entrades dels resultats
	 * @return Array d'objectes que conte la informacio de la base de dades
	 */
	function getData()
	{
		if (empty( $this->_data )) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query );
			$resultats = array();
			$noms = array();
			$boto = null;
			$seleccio = null;
			$check = null;
			$dates = array();
			$usuaris = array(0, 0);
			for ($i=0, $n=count( $this->_data ); $i < $n; $i++) {
      		$row =& $this->_data[$i];
					//construim la llista de resultats del formulari
					if ($row->id_usuari == 0) { // Contem el nombre de respostes per usuaris registrats o no registrats
						$usuaris[0] ++;
					} else {
						$usuaris[1] ++;
					}
					$dates[] = $row->data;
					$campvalor_resultat = explode("||\n",$row->parametres); // tenim en una linia el camp i el valor de un camp de un resultat

					foreach ($campvalor_resultat as $parell) {
						$parell = explode('=',$parell,2); // 0-> id_camp, 1->valor
						if (strpos($parell[0],'camp') !== false) { 
							$parell[0] = str_replace('camp','',$parell[0]); // treiem la paraula camp per que ens quedi nomes el Identificador de camp
							$info_camp = $this->getCamp($parell[0]); // 0-> nom_camp, 1-> tipus, 2-> opcions
							if ($info_camp[1] == 'radio') {
								$noms[1][0] = $info_camp[0];
								$noms[1][1] = 1;
								$botons = explode(',',$info_camp[2]);
								for ($x=0, $y=count( $botons ); $x < $y; $x++) {
									if ($botons[$x] == $parell[1]) {
										$boto->$botons[$x]->suma ++ ;
										$boto->$botons[$x]->nom = $botons[$x];
									}
								}
							}
							if ($info_camp[1] == 'select') {
								$noms[2][0] = $info_camp[0];
								$noms[2][1] = 2;
								$seleccions = explode(',',$info_camp[2]);
								for ($x=0, $y=count( $seleccions ); $x < $y; $x++) {
									if ($seleccions[$x] == $parell[1]) {
										$seleccio->$seleccions[$x]->nom = $seleccions[$x];
										$seleccio->$seleccions[$x]->suma ++ ;
									}
								}
							}
							if ($info_camp[1] == 'checkbox') {
								$noms[3][0] = $info_camp[0];
								$noms[3][1] = 3;
								$checks_resultats = explode(',',$parell[1]);
								$checks = explode(',',$info_camp[2]);
								for ($x=0, $y=count( $checks ); $x < $y; $x++) {
									foreach ($checks_resultats as $cr) {
										if ($checks[$x] == $cr) {
											$check->$checks[$x]->suma ++ ;
											$check->$checks[$x]->nom = $checks[$x];
										}
									}
								}
							}
						}
					}
					$resultats[0] = $noms;
					if (!empty($boto)) $resultats[1] = $boto;
					if (!empty($seleccio)) $resultats[2] = $seleccio;
					if (!empty($check)) $resultats[3] = $check;
					$resultats[4] = $usuaris;
					$resultats[5] = $dates;
			}
		}
		return $resultats;
	}
	
	/**
	 * Retorna el nom, el tipus i les opcions del camp especificat
	 * @param Identificador (int) del camp
	 * @return Array d'objectes que conte el nom, tipus i opcions del camp
	 */
	function getCamp($id)
	{
   $db =& JFactory::getDBO();
 
   $query = "SELECT nom, tipus, opcions FROM #__jmform_camps"
   . " WHERE id = ".$id;
   $db->setQuery( $query );
   $camp = $db->loadRow();
   
   return $camp;
	}
	
	/**
 	 * Metode que obt el identificador del formulari
 	 * @access public
 	 * @return ID del formulari
 	 */
	function getIdForm()
	{
  	return $this->_idForm;
	}
	
	/**
 	 * Metode que obt el nom del formulari
 	 * @access public
 	 * @return Nom del formulari
 	 */
	function getNomForm()
	{
   $db =& JFactory::getDBO();
 
   $query = "SELECT nom FROM #__jmform_formularis"
   . " WHERE id = ".$this->_idForm;
   $db->setQuery( $query );
   $nomform = $db->loadResult();
 
   return $nomform;
	}

}
