<?php
/**
 * @package JMForm
 * @link http://www.maruny.cat/jmform
 * @license GNU/GPL
 */

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * JMForm Model
 * @package JMForm
 */
class JmformModelResultatstaula extends JModel
{
	/**
	 * JMForm entry array
	 * @var array
	 */

	var $_data = null;
	var $_idForm = null;
	
	/**
	 * Constructor, ens dona l'ID que es passa a l'URL com a variable
	 * @access public
	 * @return void
	 */
	function __construct()
	{
	    parent::__construct();
	
	    $array = JRequest::getVar('fid',  0, '', 'array');
	    $this->setIdForm((int)$array[0]);
	}
	
	/**
 	 * Metode que afegeix un ID de formulari
 	 * @access public
 	 * @param Identificador (int) del formulari
 	 * @return void
 	 */
	function setIdForm($id)
	{
    	// Afegeix l'ID
    	$this->_idForm = $id;
	}
	
	/**
	 * Fa una consulta a la base de dades de resultats
	 * @return Un string que utilitzarem per treure la informacio de la taula
	 */
	function _buildQuery()
	{
		$query = "SELECT r.*, u.name as autor, f.nom as nomform FROM #__jmform_resultats as r"
		. " LEFT JOIN `#__users` AS u on r.id_usuari = u.id"
		. " LEFT JOIN `#__jmform_formularis` AS f on r.id_formulari = f.id"
		. " WHERE id_formulari = ".$this->_idForm
		. " ORDER BY data DESC";
	
		return $query;
	}
	
	/**
	 * Obte les entrades dels resultats
	 * @return Els resultats del formulari
	 */
	function getData()
	{
		if (empty( $this->_data )) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query );
			$resultats = array(); // 0-> id_camp, 1-> valor, 2-> nom_camp, 3-> tipus_camp
			for ($i=0, $n=count( $this->_data ); $i < $n; $i++) {
      		$row =& $this->_data[$i];
      			
					//construim la llista de resultats del formulari
					$campvalor_resultat = explode("||\n",$row->parametres);
					foreach ($campvalor_resultat as $parell) {
						$parell = explode('=',$parell,2);
						if (strpos($parell[0],'camp') !== false) {
							$parell[0] = str_replace('camp','',$parell[0]);
							$resultats[$parell[0]][0] = $parell[0];
							$resultats[$parell[0]][1] = $parell[1];
						}
					}
					$this->_data[$i]->params = $resultats;
			}
		}
		return $this->_data;						
	}
	
	/**
	 * Retorna el ID i el nom dels camps del formulari actual
	 * @return Array d'objectes que conte el ID i el nom dels camps 
	 */
	function getCamps()
	{
   $db =& JFactory::getDBO();
 
   $query = "SELECT id, nom FROM #__jmform_camps"
   . " WHERE tipus != 'button' AND tipus != 'reset button' AND tipus != 'free text' AND tipus != 'image button'"
   . " AND published = 1 AND id_formulari = ".$this->_idForm
   . " ORDER BY ordre";
   $db->setQuery( $query );
   $camps = $db->loadRowList();
   
   return $camps;
	}
	
	/**
 	 * Metode que obt el identificador del formulari
 	 * @access public
 	 * @return ID del formulari
 	 */
	function getIdForm()
	{
  	return $this->_idForm;
	}
	
	/**
 	 * Metode que obt el nom del formulari
 	 * @access public
 	 * @return Nom del formulari
 	 */
	function getNomForm()
	{
   $db =& JFactory::getDBO();
 
   $query = "SELECT nom FROM #__jmform_formularis"
   . " WHERE id = ".$this->_idForm;
   $db->setQuery( $query );
   $nomform = $db->loadResult();
 
   return $nomform;
	}
	
	/**
	 * Metode que elimina els resultats marcats
   * @access public
   * @return Cert si finalitza correctament
 	 */
	function delete()
	{
	    $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
	    $row =& $this->getTable();
	
	    foreach($cids as $cid) {
	        if (!$row->delete( $cid )) {
	            $this->setError( $row->_db->getErrorMsg() );
	            return false;
	        }
	    }
	
	    return true;
	}

}
